VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SetPictures"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
'   vpeB
'
'
    Private ROWS_OF_PAGE As Integer         '1y[W̍s(y[WԃItZbg)
    Private COLUMNS_OF_PAGE As Integer      '1y[W̗
    Private FIRST_ROWINDEX As Integer       'ԍŏɎʐ^\ts(Row)
    Private PICTURE_SET_COLUMN As Integer   'ʐ^\tZԍ
    Private PICTURES_ON_PAGE As Integer     '1y[Wɂʐ^
    Private PICTURE_OFFSET As Integer       'y[W̎ʐ^Ԃ̃ItZbg
    Private PICTURE_WIDTH As Integer        'ʐ^TCY(|Cg)
    Private PICTURE_HEIGHT As Integer       'ʐ^cTCY(|Cg)
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



Public Sub setpicture(ByVal rowsofpage As Integer, _
                ByVal columnsofpage As Integer, _
                ByVal firstrowindex As Integer, _
                ByVal picturesetcolumn As Integer, _
                ByVal picturesonpage As Integer, _
                ByVal pictureoffset As Integer, _
                ByVal picturewidth As Integer, _
                ByVal pictureheight As Integer)
    
    ROWS_OF_PAGE = rowsofpage
    COLUMNS_OF_PAGE = columnsofpage
    FIRST_ROWINDEX = firstrowindex
    PICTURE_SET_COLUMN = picturesetcolumn
    PICTURES_ON_PAGE = picturesonpage
    PICTURE_OFFSET = pictureoffset
    PICTURE_WIDTH = picturewidth
    PICTURE_HEIGHT = pictureheight


    ' PICTURE_WIDTH,PICTURE_HEIGHT |CgvZ@
    '    25.4mm / 72 * 400|Cg = 141mm
    '                 100mm̃|Cg = 100mm / (25.4mm / 72) = 283



    Dim folderpath As String
    Dim filename As String
    Dim total_picture As Integer    'ʐ^̑
    Dim total_page As Integer       '\t̑y[W
    Dim MyRange As Range
    Dim rowindex As Integer
    
    
    Call DeletePic                      '̎ʐ^폜
    folderpath = GetFolderPath          'tH_[pX擾
    
    Application.ScreenUpdating = False
    
    total_picture = Count_Picture(folderpath)
    total_page = TotalPage(total_picture, PICTURES_ON_PAGE)
    
    filename = Dir(folderpath & "\*.jpg", vbNormal)
    
       
    For i = 0 To total_page - 1
        rowindex = ROWS_OF_PAGE * i + FIRST_ROWINDEX
        
        For j = 0 To PICTURES_ON_PAGE - 1
        
            If filename <> "" Then
                Set MyRange = Cells(rowindex + PICTURE_OFFSET * j, PICTURE_SET_COLUMN)
                Call processing_setpicture(MyRange, folderpath & "\" & filename, PICTURE_WIDTH, PICTURE_HEIGHT)
                filename = Dir()
            End If
            
        Next
    Next
    
    Call SetPrintArea(total_page)       'vgGAݒ
    
    Application.ScreenUpdating = True

End Sub

'//////////////////////////////////////////////////////
'
'   t@C̃JEg
'
'       folderpath tH_[̃pX
'
'//////////////////////////////////////////////////////

Private Function Count_Picture(ByVal folderpath As String)

    Dim filename As String
    Dim count As Integer
    Dim total_page As Integer

    filename = Dir(folderpath & "\*.jpg", vbNormal)
       
    Do While filename <> ""
        count = count + 1
        filename = Dir()
    Loop
    
    Count_Picture = count

End Function


'/////////////////////////////////////////////////////
'
'   Jt@C̃tH_pX擾
'
'/////////////////////////////////////////////////////

Private Function GetFolderPath() As String
    
    Dim obj_F_Path As Object
    
    Set obj_F_Path = CreateObject("Shell.Application").browseforfolder(0, "ǂݍ݂摜tH_wB", 0)

    If Not obj_F_Path Is Nothing Then
        GetFolderPath = obj_F_Path.items.Item.Path
    End If
    
    Set obj_F_Path = Nothing
    
End Function
   
    
'//////////////////////////////////////////////////////
'
'   y[W̎Zo
'
'       pic_count ʐ^
'       picture 1y[Wɂʐ^
'
'//////////////////////////////////////////////////////

Private Function TotalPage(ByVal pic_count As Integer, ByVal picture) As Integer
    
    Select Case pic_count Mod picture
        Case 0
            TotalPage = Fix(pic_count / picture)
            
        Case Is >= 1
            TotalPage = Fix(pic_count / picture) + 1
        Case Else
    End Select
    
End Function


'************************************************
'
'   摜f[^𐮌`ē\t
'
'       MyRange \tZW
'       filepath \tt@C̃pX
'
'************************************************
Private Sub processing_setpicture(ByVal MyRange As Range, ByVal filepath As String, ByVal pic_width As Integer, ByVal pic_height As Integer)
                
    ActiveSheet.Shapes.AddPicture filepath, False, True, MyRange.Left, MyRange.Top, pic_width, pic_height
                    
End Sub


'********************************************
'
'   摜f[^̍폜
'
'********************************************

Private Sub DeletePic()

    Dim oShape As Shape

    For Each oShape In ActiveSheet.Shapes
        oShape.Delete
    Next
    
End Sub


'*********************************************
'
'   y[Wݒ
'
'       total_page y[W
'
'*********************************************

Private Sub SetPrintArea(ByVal total_page As Integer)

    ActiveSheet.PageSetup.PrintArea = Range(Cells(1, "A"), Cells(total_page * ROWS_OF_PAGE, COLUMNS_OF_PAGE)).Address
    
End Sub

